<script>
import { mapState } from "vuex";
import Vue from "vue";
import {
  GlButton,
  GlFormSelect,
  GlFormGroup,
  GlModal,
  GlModalDirective,
  GlSkeletonLoading,
  GlLoadingIcon
} from "@gitlab/ui";

const LOREM_IPSUMS = [
  "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nullam mattis commodo justo non consequat. Nulla consequat ex nulla, at vulputate libero venenatis quis. Maecenas ante lacus, lobortis id sem eget, imperdiet consequat metus. Nam velit massa, sodales eu nulla sit amet, ultricies ultricies dolor. Suspendisse potenti. Fusce posuere at nulla at pellentesque. Sed finibus iaculis quam et bibendum.",
  "Vestibulum pellentesque at est a bibendum. Phasellus faucibus quis nunc at pellentesque. Aenean consequat eros et finibus consectetur. Sed accumsan sollicitudin enim eu malesuada. Maecenas dapibus bibendum gravida. Duis malesuada pharetra leo, eget sollicitudin eros lacinia vitae. Phasellus quis tortor ultricies, consequat purus ut, rhoncus mi. Quisque ac felis at augue cursus ullamcorper nec at felis. Sed venenatis felis et odio auctor pellentesque.",
  "Pellentesque nulla tellus, tincidunt quis tincidunt quis, feugiat sed diam. Etiam malesuada est fringilla, accumsan lorem vel, tristique nisl. Cras non risus nisi. Proin molestie lectus sit amet nibh imperdiet, a faucibus diam molestie. Mauris semper mattis pretium. Aenean convallis libero quis arcu ornare, vel tincidunt nulla tempor. Quisque quis facilisis orci. Cras pulvinar consectetur massa, eu ullamcorper leo pretium at. Praesent nulla justo, tristique nec auctor a, imperdiet convallis elit. Cras consectetur est ex, vel molestie arcu maximus finibus. Praesent rutrum massa diam, id tristique eros rutrum eget. Aenean ut quam non quam ornare aliquet ac quis augue. Duis tortor neque, eleifend ut neque et, tincidunt commodo ligula.",
  "Praesent mauris risus, pretium at eros a, iaculis sodales lorem. Maecenas facilisis et erat sit amet eleifend. Vestibulum malesuada quis elit id ornare. Suspendisse quis mattis eros, quis ultricies arcu. Integer ultricies mauris non lacus ultricies, vel dignissim odio sollicitudin. Pellentesque risus felis, vulputate a efficitur ac, aliquam quis odio. Duis elit elit, pulvinar quis augue id, ultricies tincidunt augue.",
  "Aliquam eu dapibus sapien, eu ultricies massa. Nulla ullamcorper ultricies turpis. Duis eget justo ac justo fringilla porta et vel nibh. Cras dapibus at sapien vitae pellentesque. Sed vel diam et ligula varius gravida id vel metus. Nullam tempor odio ut imperdiet sollicitudin. Sed tincidunt dolor ipsum, vitae congue lacus consequat lacinia. Maecenas aliquet dolor eget dignissim fermentum."
];

export default Vue.extend({
  components: {
    GlButton,
    GlFormSelect,
    GlFormGroup,
    GlModal,
    GlSkeletonLoading,
    GlLoadingIcon
  },
  directives: {
    GlModal: GlModalDirective
  },
  props: {
    count: {
      type: Number,
      required: false,
      default: 3
    }
  },
  data() {
    return {
      loremIpsums: [],
      isLoading: true,
      isLoadingTimeout: 0,
      branches: ["master", "feat-1", "feat-2", "feat-3"]
    };
  },
  created() {
    this.refresh();
  },
  watch: {
    branch(val) {
      if (!this.branches.some(x => x === val)) {
        this.branches.push(val);
      }
    }
  },
  methods: {
    getRandomLoremIpsum() {
      const idx = Math.floor(Math.random() * LOREM_IPSUMS.length);
      return LOREM_IPSUMS[idx];
    },
    createRandomLoremIpsums() {
      return new Array(this.count)
        .fill(0)
        .map(() => this.getRandomLoremIpsum());
    },
    refresh() {
      this.isLoading = true;
      this.loremIpsums = [];

      this.isLoadingTimeout = setTimeout(() => {
        this.loremIpsums = this.createRandomLoremIpsums();
        this.isLoading = false;
      }, 2000);
    },
    destroyRefresh() {
      clearTimeout(this.isLoadingTimeout);
    },
    changeBranch(val) {
      console.log(val);
    }
  },
  computed: {
    ...mapState(["branch"])
  }
});
</script>

<template>
  <div class="glt-px-3 glt-ml-7px">
    <gl-form-group label="Select a branch:">
      <gl-form-select :value="branch" @input="changeBranch" :options="branches">
      </gl-form-select>
    </gl-form-group>
    <gl-form-group label="Open a modal:">
      <gl-button v-gl-modal="'gl-modal-id'">Open</gl-button>
      <gl-loading-icon inline v-if="isLoading" />
    </gl-form-group>
    <gl-modal
      modal-id="gl-modal-id"
      title="Lorem Ipsum"
      no-fade
      @show="refresh"
      @hide="destroyRefresh"
    >
      <template v-if="isLoading">
        <p>Here's some skeleton loaders...</p>
        <gl-skeleton-loading />
        <gl-skeleton-loading />
        <gl-skeleton-loading />
      </template>
      <template v-else>
        <p v-for="(loremIpsum, index) in loremIpsums" :key="index">
          {{ loremIpsum }}
        </p>
      </template>
    </gl-modal>
  </div>
</template>
